      PROGRAM DYX
C     -----------------------
*     
*     
*    TO BE CITED AT ANY TIME OF USE:
*     
*    J.~Bl\"umlein, V.~Ravindran,
*    ``Mellin moments of the next-to-next-to leading order coefficient functions for the
*    Drell-Yan process and hadronic Higgs-boson production,''
*    Nucl.\ Phys.\  {\bf B716 } (2005)  128-172.
*    [hep-ph/0501178].
*    
*    J. Bl\"umlein
*    ``Analytic continuation of Mellin transforms up to two loop order,''
*    Comput.\ Phys.\ Commun.\  {\bf 133 } (2000)  76-104.
*    [hep-ph/0003100].
*    
*
*     AIND etc.: Piessens, Angew. Informatik {\bf 9} (1973) 399
*
*
      IMPLICIT REAL*8 (A-H,O-Z)
      DOUBLE PRECISION LAMBDA,KFACT1,KFACT2
      COMMON/VAR/ XX
      COMMON/RIN/XMH,XMUF,XNF 
      COMMON/SET/MODE,MODH,MODP
      COMMON/ALS/XMUR,LAMBDA,AS
      COMMON/FACDY/FAC
      COMMON/MACHINE/RSEXP1,RSEXP2
      COMMON/RUN/NL
      DIMENSION CROSS0(30,20),CROSS1(30,20),CROSS2(30,20)
      DIMENSION CRQQB0(30,20)
      DIMENSION CRQQB1(30,20),CRQG1(30,20)
      DIMENSION CRQQB2(30,20),CRQQ2(30,20),CRQG2(30,20),CRGG2(30,20)
      DIMENSION SMU(3)
      DIMENSION SC(20)
      DATA SMU/0.50D0,1.0D0,2.0D0/
      DATA SC/0.10D0,0.20D0,0.30D0,0.40D0,0.50D0,0.60D0,
     &        0.70D0,0.80D0,0.90D0,1.0D0,
     &        1.10D0,1.20D0,1.30D0,1.40D0,1.50D0,1.60D0,
     &        1.70D0,1.80D0,1.90D0,2.0D0/
      EXTERNAL ALFAS1,ALFAS2,ALFAS3
      EXTERNAL HQQB0,HQQB1,HQQB2,HQQ2
      EXTERNAL HQG1,HQG2,HGG2

      PI = 3.141592653589793238462643D0
      GF=4541.680D0
      XMT=173.40D0
      CA=3.0D0
      CF=4.0D0/3.0D0
      TF=0.50D0
      XNF=4.0D0

C     MODP EXP1=1(200), EXP2=2(200)
      MODP=1

C     MACHINE: EXP1 OR EXP2
      RSEXP1=200.0D0
      RSEXP2=200.0D0

      IF(MODP.EQ.1) THEN
      WRITE(*,*) 'EXP1',RSEXP1
      ELSE
      WRITE(*,*) 'EXP2',RSEXP2
      ENDIF

C     ROOT(S) AT EXP1 AND EXP2
C     ----------------
      IF(MODP.EQ.1) THEN
      RS=RSEXP1
      ELSE
      RS=RSEXP2
      ENDIF
     
      MQMAX=30
C     Q VARIATION
      DO 124 MQ=1,MQMAX
C      DO 124 MQ=5,15,5
      XMH=MQ+1.0D0
C      XMH=MQ
      Q=XMH

C     SCALE VARIATION
      DO 125 MM=1,3
      XMUF=SMU(MM)*Q
C      DO 125 MM=4,20
C      XMUF=SC(MM)*Q
      XMUR=XMUF

C     LO, NLO, NNLO
      DO 123 JJ=1,3
      NL=JJ
      IF (NL.EQ.1) THEN
      WRITE(*,*)'************LO**************'
      WRITE(*,*)
      ELSEIF (NL.EQ.2) THEN
      WRITE(*,*)'************NLO**************'
      WRITE(*,*)
      ELSEIF (NL.EQ.3) THEN
      WRITE(*,*)'************NNLO**************'
      WRITE(*,*)
      ENDIF

      X=XMH*XMH/RS/RS

C     STRUCTURE FUNCTION AND LAMBDA
C     -----------------------------
      IF(NL.EQ.1) THEN
C     MRST02 lo2002.dat
      MODE=9
      LAMBDA=0.2200D0
      ELSEIF (NL.EQ.2) THEN
C     MRST01 alfl19.dat
      MODE=5
      LAMBDA=0.3230D0
      ELSEIF (NL.EQ.3) THEN
C     MRST02 vnval1155.dat
      MODE=1
      LAMBDA=0.2350D0
      ENDIF


C     COUPLING CONSTANTS
C     ------------------
      IF (NL.EQ.1) THEN
      ALPS=ALFAS1(XMUR,LAMBDA,XNF)
      ELSEIF (NL.EQ.2) THEN
      ALPS=ALFAS2(XMUR,LAMBDA,XNF)
      ELSEIF (NL.EQ.3) THEN
      ALPS=ALFAS3(XMUR,LAMBDA,XNF)
      ENDIF

      WRITE(*,*)'Q,MUF,MUR', XMH,XMUF,XMUR 
      WRITE(*,*)'LAMBDA,ALPS',LAMBDA,ALPS

      AS=ALPS/4.0D0/PI

      XMH2=XMH*XMH
      XMT2=XMT*XMT
      XMUR2=XMUR*XMUR
      XMUF2=XMUF*XMUF
      ALEM=1.0D0/137.0D0
      FNORM=389.3856741D+3
C     dsigma/dQ^2
      FAC=4.0D0*PI*ALEM*ALEM/3.0D0/CA/Q/Q/RS/RS
C     dsigma/dQ IN PICOBARN
      FAC=2.0D0*Q*FNORM*FAC*1.0D3

      XX=X

      IF (NL.EQ.3) THEN
      H0=FAC*HQQB0(X)
      H1Q=FAC*AS*(HQQB1(X))
      H1QG=FAC*AS*(HQG1(X))
      H2QQB=FAC*AS**2*(HQQB2(X))
      H2QQ=FAC*AS**2*(HQQ2(X))
      H2QG=FAC*AS**2*(HQG2(X))
      H2GG=FAC*AS**2*(HGG2(X))
      SIGMA2=H0+H1Q+H1QG+H2QQB+H2QQ+H2QG+H2GG

      WRITE(*,*) '      qqb0 =',H0
      WRITE(*,*) '      qqb1 =',H1Q
      WRITE(*,*) '      qg1  =',H1QG
      WRITE(*,*) '      qqb2 =',H2QQB
      WRITE(*,*) '      qq2 =',H2QQ
      WRITE(*,*) '      qg2  =',H2QG
      WRITE(*,*) '      gg2  =',H2GG
      WRITE(*,*) ' sigma^(2) =',SIGMA2


      CROSS2(MQ,MM)=SIGMA2
      CRQQB2(MQ,MM)=H0+H1Q+H2QQB
      CRQQ2(MQ,MM)=H2QQ
      CRQG2(MQ,MM)=H2QG
      CRGG2(MQ,MM)=H2GG

      ELSEIF (NL.EQ.2) THEN
      H0=FAC*HQQB0(X)
      H1Q=FAC*AS*HQQB1(X)
      H1QG=FAC*AS*HQG1(X)
      SIGMA1=H0+H1Q+H1QG

      WRITE(*,*) '      qqb0 =',H0
      WRITE(*,*) '      qqb1 =',H1Q
      WRITE(*,*) '      qg1  =',H1QG
      WRITE(*,*) ' sigma^(1) =',SIGMA1

      CROSS1(MQ,MM)=SIGMA1
      CRQQB1(MQ,MM)=H0+H1Q
      CRQG1(MQ,MM)=H1QG

      ELSEIF (NL.EQ.1) THEN
      H0=FAC*HQQB0(X)
      SIGMA0=H0
      CROSS0(MQ,MM)=SIGMA0
      CRQQB0(MQ,MM)=H0
 
      WRITE(*,*)'       qqb0 =',H0
      WRITE(*,*)'  sigma^(0) =', SIGMA0

      ENDIF

123   CONTINUE
125   CONTINUE
124   CONTINUE

C                 PLOTS     

C      OPEN(10,file="fig4.dat")
C      DO 200 MQ=1,MQMAX
C      Q=MQ+1.0D0
C      WRITE(10,*) Q, CRQQB1(MQ,2),CRQG1(MQ,2),CROSS1(MQ,2)
C200   CONTINUE
C
C      OPEN(11,file="fig5.dat")
C      DO 201 MQ=1,MQMAX
C      Q=MQ+1.0D0
C      WRITE(11,*) Q, CRQQB2(MQ,2),CRQG2(MQ,2),CRQQ2(MQ,2),CRGG2(MQ,2),
C     &               CROSS2(MQ,2)
C201   CONTINUE
C
C      OPEN(12,file="fig6.dat")
C      DO 202 MQ=1,MQMAX
C      Q=MQ+1.0D0
C      WRITE(12,*) Q, CROSS2(MQ,2),CROSS1(MQ,2),CROSS0(MQ,2)
C202   CONTINUE
C
C      OPEN(13,file="fig7.dat")
C      DO 203 MQ=1,MQMAX
C      Q=MQ+1.0D0
C      KFACT2=CROSS2(MQ,2)/CROSS0(MQ,2)
C      KFACT1=CROSS1(MQ,2)/CROSS0(MQ,2)
C      WRITE(13,*) Q, KFACT2,KFACT1
C203   CONTINUE
C
C      OPEN(14,file="fig8a.dat")
C      DO 204 MQ=1,MQMAX
C      Q=MQ+1.0D0
C      WRITE(14,*) Q, CROSS0(MQ,1),CROSS0(MQ,2),CROSS0(MQ,3)
C204   CONTINUE
C
C      OPEN(15,file="fig8b.dat")
C      DO 205 MQ=1,MQMAX
C      Q=MQ+1.0D0
C      WRITE(15,*) Q, CROSS1(MQ,1),CROSS1(MQ,2),CROSS1(MQ,3)
C205   CONTINUE
C
C      OPEN(16,file="fig8c.dat")
C      DO 206 MQ=1,MQMAX
C      Q=MQ+1.0D0
C      WRITE(16,*) Q, CROSS2(MQ,1),CROSS2(MQ,2),CROSS2(MQ,3)
C206   CONTINUE

C     FOR POLARISED DRELL-YAN PAPER
      OPEN(20,file="Fig9a.dat")
      DO 220 MQ=1,MQMAX
      Q=MQ+1.0D0
      WRITE(20,*) Q, CROSS0(MQ,1),CROSS0(MQ,2),CROSS0(MQ,3)
220   CONTINUE

      OPEN(21,file="Fig9b.dat")
      DO 221 MQ=1,MQMAX
      Q=MQ+1.0D0
      WRITE(21,*) Q, CROSS1(MQ,1),CROSS1(MQ,2),CROSS1(MQ,3)
221   CONTINUE

      OPEN(22,file="Fig9c.dat")
      DO 222 MQ=1,MQMAX
      Q=MQ+1.0D0
      WRITE(22,*) Q, CROSS2(MQ,1),CROSS2(MQ,2),CROSS2(MQ,3)
222   CONTINUE

C
C      OPEN(17,file="fig10a.dat")
C      DO 207 MM=1,20
C      RAT2=CROSS2(5,MM)/CROSS2(5,10)
C      RAT1=CROSS1(5,MM)/CROSS1(5,10)
C      RAT0=CROSS0(5,MM)/CROSS0(5,10)
C      WRITE(17,*) SC(MM), RAT2,RAT1,RAT0
C207   CONTINUE
C      OPEN(18,file="fig10b.dat")
C      DO 208 MM=1,20
C      RAT2=CROSS2(10,MM)/CROSS2(10,10)
C      RAT1=CROSS1(10,MM)/CROSS1(10,10)
C      RAT0=CROSS0(10,MM)/CROSS0(10,10)
C      WRITE(18,*) SC(MM), RAT2,RAT1,RAT0
C208   CONTINUE
C      OPEN(19,file="fig10c.dat")
C      DO 209 MM=1,20
C      RAT2=CROSS2(15,MM)/CROSS2(15,10)
C      RAT1=CROSS1(15,MM)/CROSS1(15,10)
C      RAT0=CROSS0(15,MM)/CROSS0(15,10)
C      WRITE(19,*) SC(MM),  RAT2,RAT1,RAT0
C209   CONTINUE

      RETURN
      END

      include 'PLOG.f'
      include 'FUNDY.f'
      include 'partonww.f'
