*
*
*    TO BE CITED AT ANY TIME OF USE:
*
*    J.~Bl\"umlein, V.~Ravindran,
*    ``Mellin moments of the next-to-next-to leading order coefficient functions for the
*    Drell-Yan process and hadronic Higgs-boson production,''
*    Nucl.\ Phys.\  {\bf B716 } (2005)  128-172.
*    [hep-ph/0501178].
*
*    J. Bl\"umlein
*    ``Analytic continuation of Mellin transforms up to two loop order,''
*    Comput.\ Phys.\ Commun.\  {\bf 133 } (2000)  76-104.
*    [hep-ph/0003100].
*
*
*     AIND etc.: Piessens, Angew. Informatik {\bf 9} (1973) 399
*

      PROGRAM HIGX
C     -----------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      DOUBLE PRECISION LAMBDA
      COMMON/VAR/ XX
      COMMON/DAIN/EPS,KEY,MAX
      COMMON/RIN/XMH,XMUF,XNF 
      COMMON/SET/MODE,MODH,MODP
      COMMON/ALS/XMUR,LAMBDA,AS
      COMMON/FACDY/FAC
      COMMON/MACHINE/RSLHC,RSTEV
      COMMON/RUN/NL
      DIMENSION CROSS0(30,20),CROSS1(30,20),CROSS2(30,20)
      DIMENSION SC(20)
      DATA SC/0.10D0,0.20D0,0.30D0,0.40D0,0.50D0,0.60D0,
     &        0.70D0,0.80D0,0.90D0,1.0D0,
     &        1.10D0,1.20D0,1.30D0,1.40D0,1.50D0,1.60D0,
     &        1.70D0,1.80D0,1.90D0,2.0D0/
      EXTERNAL ALFAS1,ALFAS2,ALFAS3
      EXTERNAL HG0,HG1,HG2
      EXTERNAL HGQ1,HGQ2,HQQB1,HQQB2,HQQ2

      EPS=1.0D-6
      KEY=2
      MAX=10000

      PI = 3.141592653589793238462643D0
      GF=4541.680D0
      XMT=173.40D0
      CA=3.0D0
      CF=4.0D0/3.0D0
      TF=0.50D0
      XNF=5.0D0


C     MODH MODH=1 FOR SCALAR, 2 FOR PSEUDO SCALAR
      MODH=1

C     MODP LHC=1(14000), TEVETRON=2(2000)
      MODP=1

C     MACHINE: LHC OR TEVETRON
      RSLHC=14000.0D0
      RSTEV=2000.0D0

      IF(MODP.EQ.1) THEN
      WRITE(*,*) 'LHC',RSLHC
      ELSE
      WRITE(*,*) 'TEVETRON',RSTEV
      ENDIF
      IF(MODH.EQ.1) THEN
      WRITE(*,*) 'SCALAR',MODH
      ELSE
      WRITE(*,*) 'PSEUDOSCALAR',MODH
      ENDIF

C     ROOT(S) AT LHC AND TEVETRON
C     ---------------------------
      IF(MODP.EQ.1) THEN
      RS=RSLHC
      ELSE
      RS=RSTEV
      ENDIF
C     HIGGS MASS VARIATION
C      DO 125 MH=100,300,10
      DO 125 MH=300,300
      XMH=MH
      Q=XMH

C     SCALE VARIATION
      DO 124 MM=10,10
      XMUF=SC(MM)*Q
      XMUR=XMUF

C     LO, NLO, NNLO
      DO 123 JJ=1,3
      NL=JJ
      IF (NL.EQ.1) THEN
      WRITE(*,*)'************LO**************'
      WRITE(*,*)
      ELSEIF (NL.EQ.2) THEN
      WRITE(*,*)'************NLO**************'
      WRITE(*,*)
      ELSEIF (NL.EQ.3) THEN
      WRITE(*,*)'************NNLO**************'
      WRITE(*,*)
      ENDIF

      X=XMH*XMH/RS/RS

C     STRUCTURE FUNCTION AND LAMBDA
C     -----------------------------
      IF(NL.EQ.1) THEN
      MODE=9
      LAMBDA=0.1670D0
      ELSEIF (NL.EQ.2) THEN
      MODE=5
      LAMBDA=0.2390D0
      ELSEIF (NL.EQ.3) THEN
      MODE=1
      LAMBDA=0.1760D0
      ENDIF

      WRITE(*,*)'NL,MODE,LAMBDA', NL,MODE,LAMBDA

C     COUPLING CONSTANTS
C     ------------------
      IF (NL.EQ.1) THEN
      ALPS=ALFAS1(XMUR,LAMBDA,XNF)
      ELSEIF (NL.EQ.2) THEN
      ALPS=ALFAS2(XMUR,LAMBDA,XNF)
      ELSEIF (NL.EQ.3) THEN
      ALPS=ALFAS3(XMUR,LAMBDA,XNF)
      ENDIF
      WRITE(*,*)'NL,LAMBDA,ALPS', NL,LAMBDA,ALPS

      AS=ALPS/4.0D0/PI

      XMH2=XMH*XMH
      XMT2=XMT*XMT
      XMUR2=XMUR*XMUR
      XMUF2=XMUF*XMUF
      TAUB=4.0D0*XMT2/XMH2
      TAUB2=TAUB*TAUB
      IF (TAUB.GT.1) THEN
      FTB=DASIN(0.50D0*XMH/XMT)
      ENDIF
      FTB2=FTB*FTB

      IF (MODH.EQ.1) THEN
      FBTB=1.0D0+(1.0D0-TAUB)*FTB2
      ELSE
C      FBTB=FTB2*ACOT(BETA)
      FBTB=0.0D0
      ENDIF
      FBTB2=FBTB**2
C     CB FACTOR
C     ---------
      CB0=1.0D0
      CB1=AS*(5.0D0*CA-3.0D0*CF)
      CB2=AS**2*(27.0D0/2.0D0*CF**2-100.0D0/3.0D0*CA*CF
     #       +1063.0D0/36.0D0*CA*CA-4.0D0/3.0D0*CF*TF
     #       -5.0D0/6.0D0*CA*TF+(7.0D0*CA**2-11.0D0*CA*CF)
     #       *LOG(XMUR2/XMT2)+XNF*TF*(-5.0D0*CF-47.0D0/9.0D0*CA
     #       +8.0D0*CF*LOG(XMUR2/XMT2)))

      GB2=4.0D0*DSQRT(2.0D0)*AS**2*GF*TAUB2*FBTB2
      FAC=PI*GB2/8.0D0/(CA*CA-1.0D0)

      XX=X

      IF (NL.EQ.3) THEN
      FGG0=FAC*HG0(X)
      FGG1=FAC*AS*HG1(X)+2.0D0*CB1*FGG0
      FGQ1=FAC*AS*HGQ1(X)
      FQQB1=FAC*AS*HQQB1(X)
      FGG2=FAC*AS**2*HG2(X)+(CB1**2+2.0D0*CB2)*FGG0
     #                     +2.0D0*CB1*(FAC*AS*HG1(X)+FGQ1+FQQB1)
      FGQ2=FAC*AS**2*HGQ2(X)
      FQQB2=FAC*AS**2*(HQQB2(X))
      FQQ2=FAC*AS**2*(HQQ2(X))
      SIGMA2=FGG0+FGG1+FGQ1+FQQB1+FGG2+FGQ2+FQQB2+FQQ2
      CROSS2(MH,MM)=SIGMA2

      WRITE(*,*) '          gg0=',FGG0
      WRITE(*,*) '          gg1=',FGG1
      WRITE(*,*) '          gq1=',FGQ1
      WRITE(*,*) '         qqb1=',FQQB1
      WRITE(*,*) '          gg2=',FGG2
      WRITE(*,*) '          gq2=',FGQ2
      WRITE(*,*) '         qqb2=',FQQB2
      WRITE(*,*) '          qq2=',FQQ2
      WRITE(*,*) '     sigma^(2)=',SIGMA2

      ELSEIF (NL.EQ.2) THEN
      FGG0=FAC*HG0(X)
      FGG1=FAC*AS*HG1(X)+2.0D0*CB1*FGG0
      FGQ1=FAC*AS*HGQ1(X)
      FQQB1=FAC*AS*HQQB1(X)
      SIGMA1=FGG0+FGG1+FGQ1+FQQB1

      CROSS1(MH,MM)=SIGMA1
      WRITE(*,*) '          gg0=',FGG0
      WRITE(*,*) '          gg1=',FGG1
      WRITE(*,*) '          gq1=',FGQ1
      WRITE(*,*) '         qqb1=',FQQB1
      WRITE(*,*) '    sigma^(1)=',SIGMA1

      ELSEIF (NL.EQ.1) THEN
      FGG0=HG0(X)
      SIGMA0=FAC*FGG0
      CROSS0(MH,MM)=SIGMA0
      WRITE(*,*) '          gg0=',FGG0
      WRITE(*,*) '    sigma^(0)=',SIGMA0
      ENDIF
      
123   CONTINUE
      FACK1=SIGMA1/SIGMA0
      FACK2=SIGMA2/SIGMA0


124   CONTINUE
125   CONTINUE

      DO 200 MH=100,200,50
      DO 201 MM=1,20
      RAT0=CROSS0(MH,MM)/CROSS0(MH,10)
      RAT1=CROSS1(MH,MM)/CROSS1(MH,10)
      RAT2=CROSS2(MH,MM)/CROSS2(MH,10)
      WRITE(1,*) SC(MM),RAT0,RAT1,RAT2
201   CONTINUE
200   CONTINUE
      RETURN
      END

      include 'PLOG.f'
      include 'FUNHIGGS.f'
      include 'partonww.f'
