      DOUBLE PRECISION FUNCTION FLI2(X)
C     ---------------------------------
C************************************************************************
C
C     J. BLUEMLEIN:  01.10.1999 (1.00)
C
C************************************************************************
C
C---  LI2(X)
C
C************************************************************************
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      EXTERNAL FR1
C
      PI = 3.141592653589793238462643D0
      ZETA2 = PI**2/6.0D0
C
      IF(X.LT.-1.0D0.OR.X.GT.1.0D0) GOTO 100
      IF(X.EQ.1.0D0)  GOTO 5
      IF(X.EQ.-1.0D0) GOTO 6
      IF(X.LT.0.0D0)  GOTO 1
      IF(X.EQ.0.0D0)  GOTO 2
      IF(X.GT.0.5D0)  GOTO 3
      T=FR1(X)
      GOTO 200
100   WRITE(6,*) 'FLI2 -> NOT ALLOWED,X=',X,'STOP ***'
      STOP
1     Y=-X
      IF(Y.GT.0.5D0) GOTO 4
      Y2=Y**2
      T=FR1(Y2)/2.0D0-FR1(Y)
      GOTO 200
2     T=0.0D0
      GOTO 200
3     XM=1.0D0-X
      T=-FR1(XM)-LOG(X)*LOG(XM)+ZETA2
      GOTO 200
4     YM=1.0D0-Y
      T1=-FR1(YM)-LOG(Y)*LOG(YM)+ZETA2
      Y2=Y**2
      IF(Y2.LT.0.5) THEN
      T2=FR1(Y2)
      ELSE
      T2=-FR1(1.0D0-Y2)-LOG(Y2)*LOG(1.0D0-Y2)+ZETA2
      ENDIF
      T=T2/2.0D0-T1
      GOTO 200
5     T=ZETA2
      GOTO 200
6     T=-ZETA2/2.0D0
      GOTO 200
C
200   FLI2=T
C
      RETURN
      END
      DOUBLE PRECISION FUNCTION FR1(X)
C     --------------------------------
C************************************************************************
C
C     J. BLUEMLEIN:  01.10.1999 (1.00)
C
C************************************************************************
C
C---  SUBSIDIARTY ROUTINE FOR  LI2(X)
C
C************************************************************************
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      Y=LOG(1.0D0-X)
      Y2=Y*Y
C
      T = (-1.D0+(-1.D0/4.D0+(-1.D0/36.D0+(1.D0/3600.D0+(
     &-1.D0/211680.D0+(1.D0/10886400.D0+(-1.D0/526901760.D0
     &+(691.D0/16999766784000.D0+(-1.D0/1120863744000.D0
     &+3617.D0/0.18140058832896D18*Y2)*Y2)*Y2)*Y2)*Y2)*Y2)
     &*Y2)*Y)*Y)*Y
C
      FR1=T
C
      RETURN
      END
      DOUBLE PRECISION FUNCTION FLI3(X)
C     -----------------------------------
C********************************************************************
****
C
C     J. BLUEMLEIN:  01.10.1999 (1.00)
C
C********************************************************************
****
C
C---  LI3(X) FOR -1. LE . X . LE .+1
C
C********************************************************************
****
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      A=1D0
      F=0D0
      AN=0D0
      TCH=1D-16
1     AN=AN+1D0
      A=A*X
      B=A/AN**3
      F=F+B
      IF(ABS(B)-TCH)2,2,1
2     FLI3=F
      END
      DOUBLE PRECISION FUNCTION S12(Z)
C     --------------------------------
C********************************************************************
****
C
C     J. BLUEMLEIN:  01.10.1999 (1.00)
C
C********************************************************************
****
C
C---  NIELSEN INTEGRAL: S12(X)
C
C********************************************************************
****
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      EXTERNAL FINT
C
      EPS = 1.0D-5
      KEY = 2
      MAX = 10000
C
      F = DAIND1(0.0D0,Z,FINT,EPS,KEY,MAX,KOU,EST)
      S12 = F/2.0D0
      RETURN
      END

      DOUBLE PRECISION FUNCTION FINT(Y)
C     ---------------------------------
C********************************************************************
****
C
C     J. BLUEMLEIN:  01.10.1999 (1.00)
C
C************************************************************************
C
C---  SUBSIDIARY ROUTINE FOR THE NIELSEN INTEGRAL: S12(X)
C
C************************************************************************
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      FINT = LOG(1.0D0-Y)**2/Y
      RETURN
      END

      DOUBLE PRECISION FUNCTION DAIND(A,B,FUN,EPS,KEY,MAX,KOUNT,EST)
C     --------------------------------------------------------------
C************************************************************************
C
C---  INTEGRATION ROUTINE:
C     CF. R. PIESSENS, ANGEW. INFORMATIK, VOL. 9 (1973) 399.
C
C************************************************************************
C
C  INPUTPARAMETERS
C  A,B      LIMITS OF THE INTEGRATION INTERVAL
C  FUN      FUNCTION TO BE INTEGRATED (TO BE DECLARED EXTERNAL IN THE MAIN PR.)
C  EPS      ABSOLUTE OR RELATIVE TOLERANCE,DEPENDING OF THE VALUE OF 'KEY'
C  KEY      =1 THEN 'EPS' DENOTES AN ABSOLUTE, =2 THEN A RELATIVE TOLERANCE
C  MAX      UPPER BOUND ON THE NUMBERS OF INTEGRAND EVALUATIONS (MAX.LE.10000)
C
C  OUTPUTPARAMETERS
C  KOUNT    NUMBER OF INTEGRAND EVALUATIONS
C  EST      ESTIMATION OF THE ABSOLUTE ERROR OF THE APPROXIMATION
      IMPLICIT REAL*8 (A-H,O-Z)
      DOUBLE PRECISION MAXIM,MINIM,MODUL1,MODUL2
      INTEGER RANG(130)
      DIMENSION
     &AINIT(250),END(250),EPSIL(250),PART(250),W1(5),W2(5),W3(6),
     &     X1(5),X2(5)
      DATA X1/0.973906528517D+0,0.865063366689D+0,0.679409568299D+0,
     *         0.433395394129D+0,0.148874338981D+0/
      DATA X2/0.995657163026D+0,0.930157491356D+0,0.780817726586D+0,
     *         0.562757134669D+0,0.294392862701D+0/
      DATA W1/0.666713443087D-1,0.149451349151D+0,0.219086362516D+0,
     *         0.269266719310D+0,0.295524224715D+0/
      DATA W2/0.325581623080D-1,0.750396748109D-1,0.109387158802D+0,
     *         0.134709217311D+0,0.147739104901D+0/
      DATA W3/0.116946388674D-1,0.547558965744D-1,0.931254545837D-1,
     *         0.123491976262D+0,0.142775938577D+0,0.149445554003D+0/
      DATA TOL/0.23D-15/
      EXTERNAL FUN
      MAX1 = (MAX+21)/42+1
      MAX2 = MAX1/2+2
      ALFA = A
      BETA = B
      MAAT = 1
C EVALUATION OF GAUSSIAN AND KRONROD FORMULAS
   10 S = 0.5D+0*(BETA-ALFA)
      U = 0.5D+0*(BETA+ALFA)
      RES1 = 0.0D+0
      RES2 = W3(6)*FUN(U)
      DO 20 K = 1,5
        C = S*X1(K)
        C = FUN(C+U)+FUN(U-C)
        RES1 = RES1+W1(K)*C
        RES2 = RES2+W2(K)*C
        C = S*X2(K)
   20   RES2 =RES2+W3(K)*(FUN(C+U)+FUN(U-C))
      PAT = RES2*S
      MODUL2 = ABS(PAT-RES1*S)
      IF(MAAT.GT.1) GOTO 50
      EST = MODUL2
      BINT = PAT
      KOUNT =21
      PART(1) = BINT
      GOTO 90
   30 RANG(1) = 1
      AINIT(1) = A
      END(1) = B
      EPSIL(1) = EST
   40 NR = RANG(1)
      BINT = BINT-PART(NR)
      EST =EST-EPSIL(NR)
C THE SUBINTERVAL WITH LARGEST ERROR IS SPLIT UP INTO TWO EQUAL PARTS
      ALFA = AINIT(NR)
      BETA = (AINIT(NR)+END(NR))*0.5
      JJ = 1
      MAAT = MAAT+1
      GOTO 10
   50 EST = EST+MODUL2
      BINT = BINT+PAT
      IF(JJ.EQ.0) GOTO 60
      MODUL1 = MODUL2
      PAT1 = PAT
      ALFA = BETA
      BETA = END(NR)
      JJ = 0
      GOTO 10
   60 MA = MAAT
      IF(MAAT.GT.MAX2) MA = MAX1+3-MAAT
      IF(MODUL1.GT.MODUL2) GOTO 70
      EPSIL(NR) = MODUL2
      EPSIL(MAAT) = MODUL1
      AINIT(MAAT) = AINIT(NR)
      AINIT(NR) = ALFA
      END(MAAT) = ALFA
      MAXIM = MODUL2
      MINIM = MODUL1
      PART(NR) = PAT
      PART(MAAT) = PAT1
      GOTO 80
   70 EPSIL(NR) = MODUL1
      EPSIL(MAAT) = MODUL2
      END(MAAT) = BETA
      END(NR) = ALFA
      AINIT(MAAT) = ALFA
      MAXIM = MODUL1
      MINIM = MODUL2
      PART(NR) = PAT1
      PART(MAAT) = PAT
   80 KOUNT = KOUNT+42
C TEST ON THE NUMBER OF FUNCTION EVALUATIONS
      IF(KOUNT.GE.MAX) GOTO 190
   90 GOTO (100,110),KEY
C TEST ON ABSOLUTE ACCURACY
  100 IF(EST.LE.EPS) GOTO 190
      GOTO 120
C TEST ON RELATIVE ACCURACY
  110 IF(ABS(EPS*BINT).LE.TOL) GOTO 100
      IF(EST.LE.ABS(EPS*BINT)) GOTO 190
  120 IF(MAAT.EQ.1) GOTO 30
      IF(MAAT.GT.2) GOTO 130
      RANG(2) = 2
      GOTO 40
  130 MB = MA-1
C SEARCH FOR THE SUBINTERVAL WITH LARGEST ERROR
      DO 140 I = 2,MB
        IR = RANG(I)
        IF(MAXIM.GE.EPSIL(IR)) GOTO 150
  140   RANG(I-1) = RANG(I)
      RANG(MB) = NR
      RANG(MA) = MAAT
      GOTO 40
  150 RANG(I-1) = NR
      DO 160 K = I,MB
        IR = RANG(K)
        IF(MINIM.GE.EPSIL(IR)) GOTO 170
  160   CONTINUE
      RANG(MA) = MAAT
      GOTO 40
  170 DO 180 I = K,MB
        KK = MB-I+K
  180   RANG(KK+1) = RANG(KK)
      RANG(K) = MAAT
      GOTO 40
C CALCULATION OF THE INTEGRAL
  190 AIND1 = 0.0D+0
      DO 200 K = 1,MAAT
  200   AIND1 = AIND1+PART(K)
      IF(AIND1.EQ.0.0D+0)
     &        WRITE(6,*) '**** AIND=0.**** EST NOT CALCULATED'
      IF(AIND1.NE.0.0D+0) EST=EST/AIND1
      DAIND=AIND1
      RETURN
      END

      DOUBLE PRECISION FUNCTION DAIND1(A,B,FUN,EPS,KEY,MAX,KOUNT,EST)
C     --------------------------------------------------------------
C************************************************************************
C
C---  INTEGRATION ROUTINE:
C     CF. R. PIESSENS, ANGEW. INFORMATIK, VOL. 9 (1973) 399.
C
C************************************************************************
C  INPUTPARAMETERS
C  A,B      LIMITS OF THE INTEGRATION INTERVAL
C  FUN      FUNCTION TO BE INTEGRATED (TO BE DECLARED EXTERNAL IN THE MAIN PR.)
C  EPS      ABSOLUTE OR RELATIVE TOLERANCE,DEPENDING OF THE VALUE OF 'KEY'
C  KEY      =1 THEN 'EPS' DENOTES AN ABSOLUTE, =2 THEN A RELATIVE TOLERANCE
C  MAX      UPPER BOUND ON THE NUMBERS OF INTEGRAND EVALUATIONS (MAX.LE.10000)
C
C  OUTPUTPARAMETERS
C  KOUNT    NUMBER OF INTEGRAND EVALUATIONS
C  EST      ESTIMATION OF THE ABSOLUTE ERROR OF THE APPROXIMATION
      IMPLICIT REAL*8 (A-H,O-Z)
      DOUBLE PRECISION MAXIM,MINIM,MODUL1,MODUL2
      INTEGER RANG(130)
      DIMENSION
     &AINIT(250),END(250),EPSIL(250),PART(250),W1(5),W2(5),W3(6),
     &     X1(5),X2(5)
      DATA X1/0.973906528517D+0,0.865063366689D+0,0.679409568299D+0,
     *         0.433395394129D+0,0.148874338981D+0/
      DATA X2/0.995657163026D+0,0.930157491356D+0,0.780817726586D+0,
     *         0.562757134669D+0,0.294392862701D+0/
      DATA W1/0.666713443087D-1,0.149451349151D+0,0.219086362516D+0,
     *         0.269266719310D+0,0.295524224715D+0/
      DATA W2/0.325581623080D-1,0.750396748109D-1,0.109387158802D+0,
     *         0.134709217311D+0,0.147739104901D+0/
      DATA W3/0.116946388674D-1,0.547558965744D-1,0.931254545837D-1,
     *         0.123491976262D+0,0.142775938577D+0,0.149445554003D+0/
      DATA TOL/0.23D-15/
      EXTERNAL FUN
      MAX1 = (MAX+21)/42+1
      MAX2 = MAX1/2+2
      ALFA = A
      BETA = B
      MAAT = 1
C EVALUATION OF GAUSSIAN AND KRONROD FORMULAS
   10 S = 0.5D+0*(BETA-ALFA)
      U = 0.5D+0*(BETA+ALFA)
      RES1 = 0.0D+0
      RES2 = W3(6)*FUN(U)
      DO 20 K = 1,5
        C = S*X1(K)
        C = FUN(C+U)+FUN(U-C)
        RES1 = RES1+W1(K)*C
        RES2 = RES2+W2(K)*C
        C = S*X2(K)
   20   RES2 =RES2+W3(K)*(FUN(C+U)+FUN(U-C))
      PAT = RES2*S
      MODUL2 = ABS(PAT-RES1*S)
      IF(MAAT.GT.1) GOTO 50
      EST = MODUL2
      BINT = PAT
      KOUNT =21
      PART(1) = BINT
      GOTO 90
   30 RANG(1) = 1
      AINIT(1) = A
      END(1) = B
      EPSIL(1) = EST
   40 NR = RANG(1)
      BINT = BINT-PART(NR)
      EST =EST-EPSIL(NR)
C THE SUBINTERVAL WITH LARGEST ERROR IS SPLIT UP INTO TWO EQUAL PARTS
      ALFA = AINIT(NR)
      BETA = (AINIT(NR)+END(NR))*0.5
      JJ = 1
      MAAT = MAAT+1
      GOTO 10
   50 EST = EST+MODUL2
      BINT = BINT+PAT
      IF(JJ.EQ.0) GOTO 60
      MODUL1 = MODUL2
      PAT1 = PAT
      ALFA = BETA
      BETA = END(NR)
      JJ = 0
      GOTO 10
   60 MA = MAAT
      IF(MAAT.GT.MAX2) MA = MAX1+3-MAAT
      IF(MODUL1.GT.MODUL2) GOTO 70
      EPSIL(NR) = MODUL2
      EPSIL(MAAT) = MODUL1
      AINIT(MAAT) = AINIT(NR)
      AINIT(NR) = ALFA
      END(MAAT) = ALFA
      MAXIM = MODUL2
      MINIM = MODUL1
      PART(NR) = PAT
      PART(MAAT) = PAT1
      GOTO 80
   70 EPSIL(NR) = MODUL1
      EPSIL(MAAT) = MODUL2
      END(MAAT) = BETA
      END(NR) = ALFA
      AINIT(MAAT) = ALFA
      MAXIM = MODUL1
      MINIM = MODUL2
      PART(NR) = PAT1
      PART(MAAT) = PAT
   80 KOUNT = KOUNT+42
C TEST ON THE NUMBER OF FUNCTION EVALUATIONS
      IF(KOUNT.GE.MAX) GOTO 190
   90 GOTO (100,110),KEY
C TEST ON ABSOLUTE ACCURACY
  100 IF(EST.LE.EPS) GOTO 190
      GOTO 120
C TEST ON RELATIVE ACCURACY
  110 IF(ABS(EPS*BINT).LE.TOL) GOTO 100
      IF(EST.LE.ABS(EPS*BINT)) GOTO 190
  120 IF(MAAT.EQ.1) GOTO 30
      IF(MAAT.GT.2) GOTO 130
      RANG(2) = 2
      GOTO 40
  130 MB = MA-1
C SEARCH FOR THE SUBINTERVAL WITH LARGEST ERROR
      DO 140 I = 2,MB
        IR = RANG(I)
        IF(MAXIM.GE.EPSIL(IR)) GOTO 150
  140   RANG(I-1) = RANG(I)
      RANG(MB) = NR
      RANG(MA) = MAAT
      GOTO 40
  150 RANG(I-1) = NR
      DO 160 K = I,MB
        IR = RANG(K)
        IF(MINIM.GE.EPSIL(IR)) GOTO 170
  160   CONTINUE
      RANG(MA) = MAAT
      GOTO 40
  170 DO 180 I = K,MB
        KK = MB-I+K
  180   RANG(KK+1) = RANG(KK)
      RANG(K) = MAAT
      GOTO 40
C CALCULATION OF THE INTEGRAL
  190 AIND1 = 0.0D+0
      DO 200 K = 1,MAAT
  200   AIND1 = AIND1+PART(K)
      IF(AIND1.EQ.0.0D+0)
     &        WRITE(6,*) '**** AIND=0.**** EST NOT CALCULATED'
      IF(AIND1.NE.0.0D+0) EST=EST/AIND1
      DAIND1=AIND1
      RETURN
      END
